
#define V3NormalRAM   //OK
/*
#define V3LagreRAM  
*/
#define cTBT125uS               cXTAL_11M2896HZ

#include "std_8051.h"      
#include "ssb_13s.h"      

//========================================================================================
//--  -----------------------------------------------------------------------------
//========================================================================================


EXTR data unsigned char gTBascTimer;       
EXTR idata unsigned char g10msTimer;        
                                  
EXTR data unsigned char gPKeyBuffer;       
EXTR data unsigned char gPKeyScan;       
EXTR data unsigned char gMain00;       
EXTR data unsigned char gPKeyConfirmTm;
EXTR data unsigned char GPKeyData;
EXTR data unsigned char g100msTimer;

EXTR idata unsigned char g500msTimer;

EXTR idata unsigned char gMenuSelectTm;
EXTR idata unsigned char gReceive_Add;
EXTR idata unsigned char gVolme;
EXTR idata unsigned char gBass;
EXTR idata unsigned char gTreble;
EXTR idata unsigned char  gReceive_Buffer[3];
EXTR idata unsigned int  g2SSB_Command;


//========================================================================================
//-- Ŷ -----------------------------------------------------------------------------
//========================================================================================
EXTR BOOL F10msTimer;
EXTR BOOL F100msTimer;
EXTR BOOL FPKeyDecodeOk;
EXTR BOOL F500msTimer;
EXTR BOOL FDirectUp;
EXTR BOOL FPKeyStep;
EXTR BOOL FPKeyDetect;
EXTR BOOL FSSBit_Store;



//========================================================================================
//-- λ -----------------------------------------------------------------------------
//========================================================================================

#define pCSIB                   P24
#define pRESETB                 P23
#define pRS                     P22
#define pSCLK                   P21
#define pSID                    P20  

#define POutputMode             P07 


//========================================================================================
//-- ؼ붨 -----------------------------------------------------------------------
//========================================================================================

//--  -----------------------------------------------------------------------------
//========================================================================================

#define cLCM_Reset                          0xe2
#define cLCM_InitialDisplayLine             0x40
#define cLCM_Display_On                     0xaf
#define cLCM_SetPageAddress                 0xb0
#define cLCM_SetColumnAddressMSB            0x10    // High  4 - 132
#define cLCM_SetColumnAddressLSB            0x00    // Low
#define cLCM_EntireDisplayOn                0xa0
#define cLCM_PowerControl                   0x2f
#define cLCM_RegulatorResistorSelect        0x20
#define cLCM_ReferenceVoltageSelect         0x81
#define cLCM_SetStaticIndicatorState        0xac
#define cLCM_ADCSelect                      0xa0
#define cLCM_ReverseDisplay                 0xa6
#define cLCM_SelectLCD_Bias                 0xa2
#define cLCM_SHL_Select                     0xc0

#define cPKeyMask                           0x3f     /* USE = 1 */
#define cPKeyDigitEnd                       0x20
#define cPKeyDigitHome                      0x01     /* FRIST = 1 */

//----------------------------------EPP_Addr----------------------------------------------

#define pI2C_SCL                        OP10  //P30
#define pI2C_SDA                        OP12
#define pI2C_SDA_HIGH                   P13
#define pTUN_INT                        P33


//========================================================================================
//--  -----------------------------------------------------------------------------
//========================================================================================
void MDIPInitialize();
void MDELAY(BYTE gLocal_0);
void MLCD_Write(BYTE gLocal_RS, BYTE gLocal_Data);
void MDIPClearALL();
void MPKeyScan();
void MTUN_I2CStart();
void MTUN_I2CStop();
void MTUN_I2CWriteByte(BYTE gLocal_1);
BYTE MTUN_I2CReadByte(BYTE FLocal_1);                  
BYTE MI2CRead();                  
BYTE MLIBWriteString(char gLocal_XS, short gLocal_YS,WORD *pString);
BYTE MLIBWriteCharacter(char gLocal_XS, short gLocal_YS, WORD g2Local_Char);
void MLIBWriteSpace(BYTE gLocal_X, BYTE gLocal_Y);
void MDIP_LineClear(BYTE gLocal_Y, BYTE gLocal_Start, BYTE gLocal_End);
void MSSB_Polling();


