#include "F45_main.h"           


void MSSB_Initialize(){                             // ϵʼ
    pSSB_SCK = 1;                                   // ʼ SCK           
    pSSB_SIN = 1;                                   // ʼ SIN                  
    pSSB_SDD = 1;                                   // ʼ SDD                

    MSSB_Write(0x04, 0x007f);                       // жϿ, 0x007f = ж
    //  D0.= ̲ж,         D1 = U̲ж
    //  D2 = Ŀж      D3 = ʱ仯ж
    //  D4 = Ŀ仯ж        D5 = Ŀʱ仯ж
    //  D6 = 仯ж
    return;
}


void MSSB_Polling(){
    BYTE gLocal_1;

    if (!pSSB_SIN && MSSB_Read(0x08)){
//           |            |_______________ ȡĴ 0x08 , Ӧж
//           |                            
//           |____________________________ SIN  жϲ

        gLocal_1 = g2SSB_ReceiveBuffer[0] & 0xff;
        if (gLocal_1 & 0x01){                       // U̲, ֪U̲룬üĴ 0x04 0λΪ 0;֮Ϊ 1
            MSSB_Write(0x05, 0x0001);               // ж
            MSSB_USB_Insert();                      // ʾU̲
        }
        if (gLocal_1 & 0x02){         //U̲, ֪U̲üĴ 0x04  1 λΪ 0;֮Ϊ 1
            MSSB_Write(0x05, 0x0002); //ж
            MSSB_USB_Remove();        //ʾU̲
        }
        if (gLocal_1 & 0x04){         //Ŀ֪꣬Ŀ꣬üĴ 0x04  2 λΪ 0;֮Ϊ 1
            MSSB_Write(0x05, 0x0004); //ж
            MSSB_TrackEnd();          //ʾĿ
        }
        if (gLocal_1 & 0x08){         //ʱ仯.֪ʱ仯, üĴ 0x04  3 λΪ 0;֮Ϊ 1
            MSSB_Read(0x0c);          //ʱ.
            MSSB_TrackTimer();        //ʾʱ
        }
        if (gLocal_1 & 0x10){         //Ŀ仯.֪Ŀ仯, üĴ 0x04  4 λΪ 0;֮Ϊ 1
            MSSB_Read(0x0b);          //Ŀ
            MSSB_TrackNumber();       //ʾĿ
        }
        if (gLocal_1 & 0x20){         //Ŀʱ仯  Ҫʱ, üĴ 0x04  5 λΪ 0;֮Ϊ 1
            MSSB_Read(0x0d);          //ʱ
        }
        if (gLocal_1 & 0x40){         //仯   Ҫ, üĴ 0x04  6 λΪ 0;֮Ϊ 1
            if(MSSB_Read(0x0f)){      //
                MSSB_TrackName();     //ʾ
            }          
        }
    }
    return;
}




                            
                            
void MSSB_ModeWrite(BYTE gLocal_1, BYTE gLocal_2){
    do {
        FSSBit_Store = gLocal_2 & 0x01;  //
        pSSB_SDD = FSSBit_Store;         // һλ
        MSSB_SCK(0);                     // pSSB_SCK ű 
        gLocal_2 >>= 1;                  // һλ
        MSSB_SCK(1);                     // pSSB_SCK ű ׼һλ
    } while (--gLocal_1 > 0);
    return;
}

WORD MSSB_ModeRead(){
    BYTE gLocal_1; 
    WORD g2Local_1; 
    
    gLocal_1 = 0;
    do {
        MSSB_SCK(0);                       // pSSB_SCK ű 
        g2Local_1 >>= 1;                   // һλ
        MSSB_SCK(1);                       // SCK ű ׼һλ
        FSSBit_Store = pSSB_SDD;          
        if (FSSBit_Store) g2Local_1 |= 0x8000;  // յ
    } while (++gLocal_1 < 16);                 //ÿν 2 ֽ
    return g2Local_1;                      
}


BOOL MSSB_Write(BYTE gLocal_1, WORD g2Local_1){
    BYTE gLocal_2;      // |           |______________2ֽ
    BOOL FLocal_1;       //|____________________ַ Ҫ < 0x08

    FLocal_1 = 0;
    gLocal_2 = 3;                             // ʹ ط
    do {
        pSSB_SIN = 0;                         // SIN ű ׼ͼĴĵַ
        MSSB_ModeWrite(4,gLocal_1);           //  4 λĴĵַ
        pSSB_SIN = 1;                         // SIN ű ׼ͼĴ
        MSSB_ModeWrite(8, g2Local_1 & 0xff);  // ͵ 8 λ
        MSSB_ModeWrite(8, g2Local_1 >> 8);    // ͸ 8 λ
        pSSB_SDD = 1;                         //  SDD ű ׼Ӧź
        MSSB_SCK(0);                          // OTG13S Ӧź
        MSSB_SCK(1);                       
        if (pSSB_SDD != FSSBit_Store){        // SDD  FSSBit_Store ,ȷ
            FLocal_1 = 1;                          
            MSSB_SCK(0);                        
            MSSB_SCK(1);                   
            break;                            // Exit 
        }
    } while(--gLocal_2 > 0);                 
    return FLocal_1;
}


BOOL MSSB_Read(BYTE gLocal_1){
    BYTE gLocal_2;     //|_________ ַ Ҫ > 0x07
    BOOL FLocal_1;
    WORD g2Local_1;
    
    FLocal_1 = 0;
    gLocal_2 = 3;
    do {
        pSSB_SIN = 0;                     // SIN ű ׼ͼĴĵַ
        MSSB_ModeWrite(4, gLocal_1);      //  4 λĴĵַ
        pSSB_SDD = 1;                     // ׼
        pSSB_SIN = 1;                     // SIN ű ׼վ
    
        if (gLocal_1 == 0x0f){            //
            gLocal_1 = 0;
            while (1) {
                g2Local_1 = MSSB_ModeRead(); 
                g2SSB_ReceiveBuffer[gLocal_1] = g2Local_1;
                if ((g2Local_1 == 0) || (++gLocal_1 > 15)) break;
                    // gLocal_1 ȴ 15 ˳
                    // g2Local_1  0 ˳
            };
        }
        else {
            g2SSB_ReceiveBuffer[0] = MSSB_ModeRead();   // յ 16 λ
        }
        pSSB_SDD = 1;                                   //  SDD ű ׼Ӧź     
        MSSB_SCK(0);                                    // OTG13S Ӧź
        MSSB_SCK(1);             
        if (pSSB_SDD != FSSBit_Store){                  // SDD  FSSBit_Store,ȷ
            FLocal_1 = 1;                               // ȷ
            MSSB_SCK(0);                        
            MSSB_SCK(1);                       
            break;            
        }                        
    } while(--gLocal_2 > 0);
    return FLocal_1;              

}

void MSSB_SCK(BOOL FLocal_1){
    BYTE gLocal_1;

    pSSB_SCK = FLocal_1;      
    gLocal_1 = cSSB_Delay15us;      // ʱ15us
    while (--gLocal_1 > 0);
    return;
}





void MSSB_ReadFileInfo(){
    BYTE gLocal_1;
    BYTE gLocal_2;
    BYTE gLocal_3;

    if (MSSB_Read(0x0d)){ //ļ,Ƶ,
        gLocal_1 = g2SSB_ReceiveBuffer[0] & 0x7f; //ļ
        gLocal_2 = g2SSB_ReceiveBuffer[0] >> 7;   //Ƶ
        gLocal_3 = g2SSB_ReceiveBuffer[0] >> 14;  //ļ
    } 
    return;
}  
